<script>
import { GlFormRadioGroup, GlIcon, GlLink } from '@gitlab/ui';
import {
  LINUX_PLATFORM,
  MACOS_PLATFORM,
  WINDOWS_PLATFORM,
  AWS_PLATFORM,
  DOCKER_HELP_URL,
  KUBERNETES_HELP_URL,
} from '../constants';

import RunnerPlatformsRadio from './runner_platforms_radio.vue';

export default {
  components: {
    GlFormRadioGroup,
    GlLink,
    GlIcon,
    RunnerPlatformsRadio,
  },
  inject: ['awsImgPath', 'dockerImgPath', 'kubernetesImgPath'],
  props: {
    value: {
      type: String,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      model: this.value,
    };
  },
  watch: {
    model() {
      this.$emit('input', this.model);
    },
  },
  LINUX_PLATFORM,
  MACOS_PLATFORM,
  WINDOWS_PLATFORM,
  AWS_PLATFORM,
  DOCKER_HELP_URL,
  KUBERNETES_HELP_URL,
};
</script>

<template>
  <gl-form-radio-group v-model="model">
    <div class="gl-mt-3 gl-mb-6">
      <label>{{ s__('Runners|Operating systems') }}</label>

      <div class="gl-display-flex gl-flex-wrap gl-gap-5">
        <!-- eslint-disable @gitlab/vue-require-i18n-strings -->
        <runner-platforms-radio v-model="model" :value="$options.LINUX_PLATFORM">
          Linux
        </runner-platforms-radio>
        <runner-platforms-radio v-model="model" :value="$options.MACOS_PLATFORM">
          macOS
        </runner-platforms-radio>
        <runner-platforms-radio v-model="model" :value="$options.WINDOWS_PLATFORM">
          Windows
        </runner-platforms-radio>
      </div>
    </div>

    <div class="gl-mt-3 gl-mb-6">
      <label>{{ s__('Runners|Cloud templates') }}</label>
      <!-- eslint-disable @gitlab/vue-require-i18n-strings -->
      <div class="gl-display-flex gl-flex-wrap gl-gap-5">
        <runner-platforms-radio v-model="model" :image="awsImgPath" :value="$options.AWS_PLATFORM">
          AWS
        </runner-platforms-radio>
      </div>
    </div>

    <div class="gl-mt-3 gl-mb-6">
      <label>{{ s__('Runners|Containers') }}</label>

      <div class="gl-display-flex gl-flex-wrap gl-gap-5">
        <!-- eslint-disable @gitlab/vue-require-i18n-strings -->
        <runner-platforms-radio :image="dockerImgPath">
          <gl-link :href="$options.DOCKER_HELP_URL" target="_blank">
            Docker
            <gl-icon name="external-link" />
          </gl-link>
        </runner-platforms-radio>
        <runner-platforms-radio :image="kubernetesImgPath">
          <gl-link :href="$options.KUBERNETES_HELP_URL" target="_blank">
            Kubernetes
            <gl-icon name="external-link" />
          </gl-link>
        </runner-platforms-radio>
      </div>
    </div>
  </gl-form-radio-group>
</template>
